# MpdLIRC plugin for pympd

 
import gtk, gtk.glade
import pygtk
import threading
import pyosd
from SimpleXMLRPCServer import *
from mpdclient import *
from Xlib import *

__HOST__ = "zim"
__PORT__ = 6600
__FONT__ = "-*-helvetica-bold-r-*-*-34-*-*-*-*-*-*-*"
__COLOUR__ = "green"

class MpdLIRCServer:
    def __init__(self):
        # find out the screen height, so we can set the vertical offset properly

        d = display.Display()
        s = d.screen(0)
        h = s['height_in_pixels']
        self.osd = pyosd.osd(font = __FONT__, colour = __COLOUR__)
        self.osd.set_align(1)
        self.osd.set_vertical_offset(h-100)
        
    def play(self):
        client = MpdController(host = __HOST__, port = __PORT__)
        client.play()
        song = client.getCurrentSong()
        toprint = song.artist + " - " + song.title
        self.osd.display(toprint)
        return 0
    
    def stop(self):
        client = MpdController(host = __HOST__, port = __PORT__)
        client.stop()
        self.osd.display("Playback Stopped")
        return 0

    def pause(self):
        client = MpdController(host = __HOST__, port = __PORT__)
        client.pause()
        self.osd.display("Playback Paused")
        return 0
        
    def prev_song(self):
        client = MpdController(host = __HOST__, port = __PORT__)
        client.prev()
        song = client.getCurrentSong()
        toprint = song.artist + " - " + song.title
        self.osd.display(toprint)
        return 0
    
    def next_song(self):
        client = MpdController(host = __HOST__, port = __PORT__)
        client.next()
        song = client.getCurrentSong()
        toprint = song.artist + " - " + song.title
        self.osd.display(toprint)
        return 0
        
    def random(self):
        client = MpdController(host = __HOST__, port = __PORT__)
        client.random()
        s = client.status()
        if s.random is 0:
            self.osd.display("Random [off]")
        elif s.random is 1:
            self.osd.display("Random [on]")
        return 0
            
    def mute(self):
        client = MpdController(host = __HOST__, port = __PORT__)
        s = client.status()
        muted = s.volume
        if muted is not 0:
            system("aumix -S; aumix -w 0 -v 0")
            muted = 1
            self.osd.display("Muted")
        else:
            system("aumix -L")
            muted = 0
            self.osd.display("Unmuted")
        return 0
            
    def volup(self):
        client = MpdController(host = __HOST__, port = __PORT__)
        system("aumix -w +4 -v +4; aumix -S")
        s = client.status()
        self.osd.display(s.volume, pyosd.TYPE_PERCENT)
        return 0

    def voldown(self):
        client = MpdController(host = __HOST__, port = __PORT__)
        system("aumix -w -4 -v -4; aumix -S")
        s = client.status()
        self.osd.display(s.volume, pyosd.TYPE_PERCENT)
        return 0
        
class Mpdlirc:
    def _init(self, data):
        self.server = SimpleXMLRPCServer(("localhost", 1234))
        self.server.register_instance(MpdLIRCServer())
        t = threading.Thread(target=self.server.serve_forever())
        t.start()
        
    def _conf(self, hasDialog=None):
        return False
    
    # update plugin, data is of type mpdclient.Status

    def _spin(self, data):
        pass

    # called on plugin unloaded

    def _unload(self):
        self.server.server_close()
        return
